/*
  fOpen()

  open a file handle and throw an error message if it cannot be opened
*/

#include "getCoverage.h"

FILE *fOpen(const char *file, const char *format)
{
  FILE *f;
  errno = 0;

  if (file == NULL ) file = "\0"; // fopen() may choke on a NULL file

  if ((f = fopen(file,format)) == NULL)
  {
    printError("fOpen", DEBUG_ERROR,
               "ERROR: Cannot open %s for %s: %s",
               file, format, strerror(errno));

    exit(1); // Can't open
  }
  return f;
}
