#ifndef CONSENSUSSEQUENCE_HH
#define CONSENSUSSEQUENCE_HH 1

#include <iostream>
#include <vector>
#include <string>
#include <list>
#include "SequenceData.hh"
#include <SliceData.hh>

typedef list<SequenceData *> SequenceList;
typedef map<string, SequenceData *> SequenceMap;

using libSlice::SliceData;
using libSlice::ReadData;

class ConsensusSequence
{
public:
  ConsensusSequence(int contigCount, long index, ostream & out);
  ~ConsensusSequence();

  void addSlice(SliceData * slice);
  void flushSequences();

  void printTileXML(const string & prefix);

private:
  void addElement(char base, long index);

  SequenceData * getSequence(const ReadData * rd, long offset, long index); 
  SequenceData * addSequence(const ReadData * rd, long offset, long index); 

  void addActiveSequence(SequenceData * sd);

  ostream & m_out;

  string m_nuc;

  int m_contigCount;
  long m_curOffset;

  long m_asmleft;
  long m_asmright;

  int m_coordinateOffset;

  SequenceMap  m_completeSequenceMap;
  SequenceList m_completeSequenceList;

  SequenceMap m_activeSequences;
  SequenceMap m_previousSequences;
};

#endif
