#ifndef SLICETRANSLATOR_HH 
#define SLICETRANSLATOR_HH 1

#include "RequestManager.hh"
#include "Foundation.hh"

using libSlice::SliceData;
using libSlice::ConsensusData;

class SliceTranslator : public RequestManager
{
public:
  SliceTranslator();
  ~SliceTranslator();

  void addSlice(SliceData * slice);
  void addSliceRange(long & index, long & gindex);
  void addRequest(ConsensusRequest * request);
  void addReadData(ReadData * readData);

  int  printResults();
  void setTranslationCoordinates(long index, long gindex);

  static void handleOptions(Foundation * tf);

private:
  static int m_newIndex;
  static int m_newGindex;

  static int m_newSliceRangeIndex;
  static int m_newSliceRangeGindex;
};

#endif
